module Bytewise
  module Ast
    #
    # This represents raw text (e.g HTML or CSS)
    #
    class Chunk < Node
      attr_reader :chunk

      def initialize(chunk)
        @chunk = chunk
      end

      def <<(chunk)
        if chunk.is_a? String
          @chunk += chunk
        end
      end

      def to_s
        @chunk
      end

      def render(*args)
        to_s
      end
    end
  end
end