module Bytewise
  module Ast
    #
    # This is the most basic class
    # It is designed to be extended by tags, chunk, body, blocks, etc.
    #
    class Reference < Node
      attr_reader :name, :filter, :raw

      def initialize(name, filter = nil, context = :default)
        @name = name
        @filter = filter
        @context = context
      end

      #
      # Todo: Update this method to match the new context - approach
      #
      def to_s
        string = '{{'
        string += '{' if @raw
        string += " #{@name}"

        unless @filter.nil? && @filter != ''
          string += "|#{@filter}"
        end

        string += ' }}'
        string += '}' if @raw

        string
      end

      def render(ctx, *args)
        value = ctx.resolve_reference(@name)

        # Escape HTML if not raw and not inside a bracket
        if @context == :default && !value.nil? && value.is_a?(String)
          value = ::CGI::escapeHTML(value)
        end

        unless @filter.nil?
          value = ::Bytewise::Filters::Filter.apply(filter, input: value, reference: self)
        end

        value
      end
    end
  end
end