module BraceMarkup
  module Ast
    module Tags
      #
      # This is a block {{+name}}{{/name}}
      #
      class Block < ::Bytewise::Ast::Tag
        map :+
        attr_accessor :removed

        def render(context, *args)
          return if @removed

          blocks = @parent.find_blocks(@name, exclude: self)

          if @body.nil?
            result = ''
          else
            result = @body.render(context, *args)
          end

          blocks.each do |block|
            ctx = block.parent.context.nil? ? context : block.parent.context
            rendered = block.body.render(ctx, *args)

            case block.arguments[:mode]
              when 'append', 'after'
                result += rendered
              when 'prepend', 'before'
                result = rendered + result
              else
                # Default's to overwrite
                result = rendered
            end

            block.removed = true
          end


          result
        end
      end
    end
  end
end