module Bytewise
  class UnexpectedExpressionError < Exception
    def initialize(expected, actual, lexer)
      super("Unexpected '#{actual}' was expecting '#{expected}' @ #{lexer.line_and_col}")
    end
  end

  class UnexpectedCharactersException < Exception
    def initialize(expected, lexer)
      super("Unexpected '#{lexer.peek(length: expected.length)[:chunk]}' was expecting '#{expected}' @ #{lexer.line_and_col}")
    end
  end
end
