require_relative 'brace_markup/lexer'
require_relative 'brace_markup/parser'
require_relative 'brace_markup/context'
require_relative 'brace_markup/renderer'

#
# AST
#
require_relative 'brace_markup/ast/node'
require_relative 'brace_markup/ast/body'
require_relative 'brace_markup/ast/chunk'
require_relative 'brace_markup/ast/expression'
require_relative 'brace_markup/ast/reference'
require_relative 'brace_markup/ast/tag'

# ValueObjects / Special Characters
require_relative 'brace_markup/ast/chars/new_line'
require_relative 'brace_markup/ast/chars/nil'

# Operators
require_relative 'brace_markup/ast/operators/operator'

require_relative 'brace_markup/ast/operators/add'
require_relative 'brace_markup/ast/operators/equals'
require_relative 'brace_markup/ast/operators/greater_than'
require_relative 'brace_markup/ast/operators/logical_and'
require_relative 'brace_markup/ast/operators/logical_or'
require_relative 'brace_markup/ast/operators/minus'
require_relative 'brace_markup/ast/operators/modulo'
require_relative 'brace_markup/ast/operators/slash'
require_relative 'brace_markup/ast/operators/smaller_than'
require_relative 'brace_markup/ast/operators/star'

# Tags
require_relative 'brace_markup/ast/tags/block'
require_relative 'brace_markup/ast/tags/helper'
require_relative 'brace_markup/ast/tags/partial'
require_relative 'brace_markup/ast/tags/section'
require_relative 'brace_markup/ast/tags/comment'

#
# Errors
#
require_relative 'brace_markup/errors/close_tag'
require_relative 'brace_markup/errors/tag_section'
require_relative 'brace_markup/errors/unexpected_expression'
require_relative 'brace_markup/errors/unexpected_end'

#
# Filters
#
require_relative 'brace_markup/filters/filter'
require_relative 'brace_markup/filters/downcase'
require_relative 'brace_markup/filters/upcase'

#
# Helpers
#
require_relative 'brace_markup/helpers/helper'
require_relative 'brace_markup/helpers/if'
require_relative 'brace_markup/helpers/for'
require_relative 'brace_markup/helpers/math/modulus_helper'
require_relative 'brace_markup/helpers/str/split'

# Ramaze
require_relative 'innate/view/brace'