#
# Registers Brace as an engine for Ramaze.
#
# Template files can either have the extension .html or .brace.
# (HTML is suggested due to the nature of the lack of syntax highlighting for brace.)
#
if defined? Innate
  module Innate
    module View
      module Brace
        def self.call(action, string)
          context = ::Bytewise::Context.new action.instance, variables: action.variables, filename: action.view

          View.compile(string) do |str|
            html = BraceMarkup.render(str, context: context)

            return html, 'text/html'
          end
        end
      end # Brace
      register 'Innate::View::Brace', :html, :brace
    end # View
  end # Innate
end # if
